import SAMBA 3.1
import SAMBA.Connection.Serial 3.1
import SAMBA.Device.SAMA5D2 3.1

AppletLoader {
	connection: SerialConnection {
	}

	device: SAMA5D2 {
		board: "sama5d2-xplained"
	}

	onConnectionOpened: {
		// initialize serialflash applet
		print("-I- === Initialize serialflash access ===")
		appletInitialize("serialflash")

		// erase all memory
		print("-I- === Erase all the flash ===")
		appletErase(0, connection.applet.memorySize)

		// write files
		print("-I- === Load AT91Bootstrap in the first sector ===")
		appletWrite(0x00000000, "at91bootstrap-sama5d2_xplained.bin", true)

		print("-I- === Load u-boot environment ===")
		appletWrite(0x00006000, "u-boot-env.bin")

		print("-I- === Load u-boot ===")
		appletWrite(0x00008000, "u-boot-sama5d2-xplained.bin")

		print("-I- === Load device tree database ===")
		appletWrite(0x00070000, "at91-sama5d2_xplained_pda4.dtb")

		print("-I- === Load Kernel image ===")
		appletWrite(0x0007c000, "zImage-sama5d2-xplained.bin")

		print("-I- === Done. ===")
	}
}
